#include <iostream>
using namespace std;

int f2(int x[], int y[], int k){
    int s = 0;
    for(int i = 0; i < k / 2; ++i){

        if((x[i] == x[i + 1] + 1) && (y[i] == y[i + 1])){
            s = 1;
        }
        else if((y[i] == y[i + 1] + 1) && (x[i] == x[i + 1])){
            s = 1;
        } else {
            s = 0;
            i = k / 2;
        }
        if(s == k / 2){
            if (s == 1){cout << 1;} else if (s == 0) {cout << 0;}
        }
    }

}

int main(){

    int n, k;

    cin >> n;
    cin >> k;

    int brojevi[n][n];
    int t;
    int ok = 0;
    for(int i = 0; i < n; ++i){
        for(int s = 0; s < n; ++s){
            cin >> t;
            brojevi[i][s] = t;
        }
    }
    int x[n];
    int y[n];
    int kord = 0;
    for(int g = 1; g <= k; ++g){
        for(int i = 0; i < n; ++i){
            for(int s = 0; s < n; ++s){
                if(brojevi[i][s] == g){
                    x[kord] = i;
                    y[kord] = s;
                    ++kord;
                }
            }
        }

        if (kord == 1){++ok;}
        if (kord % 2 == 0){
            if(f2(x, y, kord) == 1){
                ++ok;
            }
        }

        kord = 0;
    }
    cout << ok;

}